////////////// JQUERY CONFLICT NO PLEASE

(function ($) {


    ///////////////////////////////////
    ///////     FUNCTIONS     /////////
    ///////////////////////////////////

    // debug
    window.debug = window.debug || function(log) {
        if (typeof(log) === 'undefined') return;
        if ((typeof (window.console) !== 'undefined') && (typeof (console.log) === 'function')) {
            console.log(log);
        }
    };

    // Main slideshow
    window.detectIE = window.detectIE || function() {
        var ua = window.navigator.userAgent;
        var msie = ua.indexOf('MSIE ');
        if (msie > 0) {
            return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
        }
    };


    // check for mobiles and tablets
    window.refresh_size_queries = window.refresh_size_queries || function() {
        var classes = [];
        window_width = jQuery(window).width();
        window_height = jQuery(window).height();

        window.is_mobile = (window_width < 768);
        window.is_tablet_portrait = (window_width >= 768 && window_width < 992);
        window.is_tablet_landscape = (window_width >= 992 && window_width < 1200 && window_height <= 768);
        window.is_tablet = window.is_tablet_portrait || window.is_tablet_landscape;

        if (window.is_mobile) {
            classes.push('mq_mobile');
        }
        if (window.is_tablet_portrait) {
            classes.push('mq_tablet_portrait');
        }
        if (window.is_tablet_landscape) {
            classes.push('mq_tablet_landscape');
        }
        if (window.is_tablet) {
            classes.push('mq_tablet');
        }

        jQuery('html').removeClass('mq_mobile')
            .removeClass('mq_tablet_portrait')
            .removeClass('mq_tablet_landscape')
            .removeClass('mq_tablet')
            .addClass(classes.join(' '));
    };


    // Simplified 'Supersized': keeps original image aspect ratio and centers image;
    window.resizeAndCenterImages = window.resizeAndCenterImages || function(imagesContainerSelector) {
        debug('slideshow resiz ' + jQuery(imagesContainerSelector + ' .cycle-slide').length);
        var slides = $(imagesContainerSelector).find('> div');
        var screen_width = $(imagesContainerSelector).width();
        var screen_height = $(imagesContainerSelector).height();
        var sizes = false;

        // cycling each slide
        jQuery.each(slides, function (index, slide) {
            // check if we are in the array
            //if (index >= numberOfSlides) return;
            var id = jQuery(this).data('id');
            // check if sizes are declarated
            // if (typeof sshow_image_data[index]['sizes'] !== 'undefined') {
            if (typeof sshow_image_data_sizes != 'undefined' && sshow_image_data_sizes[id]['sizes'] !== 'undefined') {
                // sizes = sshow_image_data[index]['sizes'];
                sizes = sshow_image_data_sizes[id];
            } else {
                sizes = false;
            }

            // variables
            var image_height = 0;
            var image_width = 0;
            var imageWRatio = 0;
            var imageHRatio = 0;
            var res_w = 0;
            var res_h = 0;

            //debug(sizes);
            // if sizes are declarated
            if (sizes) {
                var res = false;
                var ww = jQuery(window).width();
                for (var current_res in sizes) {
                    if (sizes.hasOwnProperty(current_res)) {
                        current_res = parseInt(current_res, 10);
                        if (res === false) res = current_res;
                        else if (current_res > res && current_res < ww) {
                            res = current_res;
                        }
                    }
                }
                image_height = sshow_image_data_sizes[id][res]['height'];
                image_width = sshow_image_data_sizes[id][res]['width'];
            } else {
                image_height = sshow_images_h;
                image_width = sshow_images_w;
            }

            // image ratios
            imageWRatio = image_width / image_height;
            imageHRatio = image_height / image_width;
            // confront ratios
            if ((res_h = screen_height) && (res_w = res_h * imageWRatio) >= screen_width) {
                ;
            }
            else {
                if ((res_w = screen_width) && (res_h = res_w * imageHRatio) >= screen_height) {
                    ;
                }
            }
            var res_ox = (res_w == screen_width ? 0 : '-' + ((res_w - screen_width) / 2));
            var res_oy = (res_h == screen_height ? 0 : '-' + ((res_h - screen_height) / 2));

            // putting dimensions and position
            jQuery(slide).find('img').css({
                'width': res_w + 'px',
                'height': res_h + 'px',
                'left': res_ox + 'px',
                'top': res_oy + 'px'
            });
        });
    };

    // Resized 2.0 : keeps original image aspect ratio and centers image;
    window.resize_images = window.resize_images || function(divs) {
        var boxes = jQuery('[data-resize=true]');
        if (boxes.length == 0) {
            if (typeof(divs) === 'undefined') return;
            boxes = jQuery(divs);
        }

        if (boxes.length > 0) {
            jQuery.each(boxes, function (index, selector) {
                var box = $(this);
                box.imagesLoaded()
                    .progress(function (instance, image) {

                    })
                    .always(function (instance) {

                    })
                    .done(function (instance) {
                        var screen_width = box.outerWidth();
                        var screen_height = box.outerHeight();
                        var img = box.find('img');
                        var img_w = img.outerWidth();
                        var img_h = img.outerHeight();
                        var image_w = (typeof (img_w) !== 'undefined') ? img_w : box.data('img_width');
                        var image_h = (typeof (img_h) !== 'undefined') ? img_h : box.data('img_height');
                        var imageWRatio = image_w / image_h;
                        var imageHRatio = image_h / image_w;
                        var res_w;
                        var res_h;
                        var res_ox;
                        var res_oy;
                        // debug
                        debug('resize .' + box.attr('class') + ' w:' + image_w + ' h:' + image_h);
                        if ((res_h = screen_height) && (res_w = res_h * imageWRatio) >= screen_width) {
                            ;
                        }
                        else {
                            if ((res_w = screen_width) && (res_h = res_w * imageHRatio) >= screen_height) {
                                ;
                            }
                        }
                        res_ox = (res_w == screen_width ? 0 : '-' + ((res_w - screen_width) / 2));
                        res_oy = (res_h == screen_height ? 0 : '-' + ((res_h - screen_height) / 2));

                        img.css({
                            'width': res_w + 'px',
                            'height': res_h + 'px',
                            'left': res_ox + 'px',
                            'top': res_oy + 'px'
                        });
                    })
                    .fail(function () {
                    });

            });
        }
    };

    //Post-loads images and starts slideshow
    window.doSlideshow = window.doSlideshow || function(imagesContainerSelector) {
        if(typeof jQuery(imagesContainerSelector) == 'undefined' || jQuery(imagesContainerSelector).size()==0 ) return false;
        var video_wrap = jQuery('#video_box');
        // i have the go only in mobile!
        if(window.is_mobile) window.go_slide = true;
        // if there is the video, AND there is no go
        if (video_wrap.size() > 0 && window.go_slide == false) return false;
        if (typeof(sshow_image_data) !== 'undefined' && sshow_image_data.length > 0) {
            // global
            numberOfSlides = sshow_image_data.length;
            // config
            var s_speed = (typeof(slide_speed) !== 'undefined' && jQuery.trim(slide_speed) !== '') ? slide_speed : 3000;
            var s_timeout = (typeof(slide_timeout) !== 'undefined' && jQuery.trim(slide_timeout) !== '') ? slide_timeout : 9000;
            $.each(sshow_image_data, function (index, imgset) {
                // jump the first, that is hardloaded in the html
                // if(index == 0 ){ return; }
                // do the other images
                var id = imgset['ID'];
                var img = jQuery('<img/>').attr('src', imgset['url_tiny']).attr('srcset', imgset['url_set']).attr('alt', imgset['title']);
                var slider = jQuery('<div class="slide"/ data-id="' + id + '">');
                slider.append(img);

                if (imgset['caption_title'] !== '' || imgset['caption_subtitle'] !== '') {
                    var caption_title = (imgset['caption_title'] !== '') ? '<div class="caption_title">' + imgset['caption_title'] + '</div>' : '';
                    var caption_subtitle = (imgset['caption_subtitle'] !== '') ? '<div class="caption_subtitle">' + imgset['caption_subtitle'] + '</div>' : '';
                    var caption = jQuery('<div class="caption" />').append(caption_title).append(caption_subtitle);
                    slider.append(caption);
                }
                $(imagesContainerSelector).append(slider);

            });
            var IEversion = detectIE();
            if (IEversion !== false) {
                jQuery(imagesContainerSelector).find('.slide img').each(function () {
                    var _img = jQuery(this).attr('srcset').split(', ');
                    _img = _img[_img.length - 1].split(' ');
                    jQuery(this).attr('src', _img[0]);
                });
            }
            // images loaded go!
            var counter = 0;
            jQuery(imagesContainerSelector).imagesLoaded()
                .progress(function (instance, image) {
                    counter++;
                    jQuery('.loading_sshow .progress').html(counter);
                })
                .always(function (instance) {
                    jQuery('.loading_sshow .total').html(instance.images + '...');
                })
                .done(function (instance) {
                    // debug('slideshow loaded');
                    // resize ss box
                    slideshowHeight();
                    // resize ss images
                    resizeAndCenterImages(imagesContainerSelector);

                    // on window resize
                    jQuery(window).resize(function () {
                        // resize ss images
                        resizeAndCenterImages(imagesContainerSelector);

                    });
                    if (sshow_image_data.length == 1) {
                        jQuery('.loading_sshow').fadeOut(2000);
                        $('#placeholder_slide_text').delay(2000).fadeOut(1000);
                    } else {
                        $('#placeholder_slide_text').delay(2000).fadeOut(1000);

                        jQuery(imagesContainerSelector).cycle({
                            speed: parseInt(s_speed, 10),
                            timeout: parseInt(s_timeout, 10),
                            'slides': ' > div ',
                            pager: '#pager'
                        }).on('cycle-after', function () {
                            jQuery('.caption').addClass('visible');
                        }).on('cycle-before', function () {
                            jQuery('.caption').removeClass('visible');
                        });
                        resizeAndCenterImages(imagesContainerSelector);
                        jQuery('.loading_sshow').fadeOut(2000);
                        picturefill();
                    }

                })
                .fail(function () {
                });
        }
    };

    // vertical align
    window.valign = window.valign || function() {
        var boxes = $('.valign');
        if (boxes.length == 0)  return;
        boxes.each(function () {
            var valign = $(this);
            valign.imagesLoaded()
                .progress(function (instance, image) {})
                .always(function (instance) {})
                .done(function (instance) {
                    var parent_h = valign.parent().height();
                    var box_h = valign.outerHeight();
                    var margin_top = parseInt((parent_h - box_h) / 2, 10);
                    if (parent_h < box_h) return;
                    valign.css({
                        "margin-top": margin_top
                    });
                })
                .fail(function () {});
        });
    };

    // function that controls the height of slideshow
    window.slideshowHeight = window.slideshowHeight || function() {
        var sshow_wrap = jQuery('#slideshow_wrapper');
        if (sshow_wrap.length == 0) return;
        //vars
        var window_width = jQuery(window).width();
        var video_wrap = jQuery('#video_box');
        var window_height = jQuery(window).height();

        // resizing
        if (window.is_mobile ) {
            //with or without domain, under 767 will be full height
            height = window_height - jQuery('#mobile_bottom_bar').height();
        } else {
            if (video_wrap.size() > 0) {
                // if i have video
                height = parseInt((jQuery(window).width()/16)*9,10);
                if(height>window_height) {
                    height = window_height ;
                }
            } else {
                // if i have no video
                if (sshow_wrap.hasClass('homepage')) {
                    // if we are in homepage
                    height = window_height;
                } else {
                    // internal pages
                    height = parseInt(window_height * 0.6, 10);
                }
            }
        }
        // putting height!
        sshow_wrap.css({
            height: height
        });
        // if there is video
        if (video_wrap.size() != 0){
            video_wrap.css({
                height: height
            });
        }
    };
    /////// END GENERAL FUNCTIONS


    //////// THEME FUNCTIONS //////////

    window.go_down = window.go_down || function() {
        var btn = $('#scroll_down');
        if (jQuery('body').hasClass('homepage') && btn.size() > 0) {
            btn.click(function () {
                $('html,body').animate({
                    scrollTop: $('#slideshow').height() - $('#header_wrapper').height()
                }, 1000);
            })
        }
    };

    // function for scrolling header;
    window.header_scroll = window.header_scroll || function() {
        // elems
        var header_wrap = jQuery("#header_wrapper");
        if (header_wrap.length == 0) return false;
        var header = jQuery("#header");
        var offset = 0;

        // waypoint
        var waypoint; //// header_wrap.outerHeight(true)
        waypoint = (header_wrap.length > 0) ? parseInt(header_wrap.outerHeight(true) + offset) : 0;


        // header check and remove or add !window.is_mobile &&
        if (jQuery('body').hasClass('home')) {
            // if i have scrolled more than header wrapper on home
            if (waypoint != 0 && jQuery(window).scrollTop() >= waypoint) {
                if (!header.hasClass('home_top')) return false;
                header.removeClass('home_top');
            } else {
                if (header.hasClass('home_top')) return false;
                header.addClass('home_top');
            }
        }
    };

    // open the menu
    window.menu_open = window.menu_open || function() {
        var btn = jQuery('.open_menu');
        var sidebar = jQuery('#sidebar');
        if (btn.length == 0 || sidebar.length == 0) return;
        var sidebar_overlay = jQuery('#sidebar_overlay');
        var mClass = ('visible');
        var htmlClass = ('no_scroll');
        var html = jQuery('html');

        btn.click(function () {
            if (!sidebar.hasClass(mClass)) {
                sidebar.addClass(mClass);
                sidebar_overlay.addClass(mClass);
                html.addClass(htmlClass);
            }
        });
        sidebar_overlay.click(function () {
            if (sidebar.hasClass(mClass)) {
                sidebar.removeClass(mClass);
                sidebar_overlay.removeClass(mClass);
                html.removeClass(htmlClass);
            }
        });
        jQuery('.close_sidebar').click(function () {
            if (sidebar.hasClass(mClass)) {
                sidebar.removeClass(mClass);
                sidebar_overlay.removeClass(mClass);
                html.removeClass(htmlClass);
            }
        });
        if (!window.is_mobile) {
            jQuery("#sidebar_box").mCustomScrollbar();
        }
    };

    // function submenu
    window.open_submenu = window.open_submenu || function() {
        var button = jQuery("#main_menu .menu .more_li");
        var parent = jQuery("li.menu-item-has-children");
        var submenu = jQuery("ul.sub-menu");
        var mClass = "open";
        var wrapper = jQuery("#sidebar_box");

        button.click(function (e) {
            e.preventDefault();
            if (!jQuery(this).closest(parent).hasClass('open')) {
                parent.removeClass(mClass);
                parent.find(submenu).stop().fadeOut();

                jQuery(this).closest(parent).find(submenu).stop().fadeIn(400,
                    function () {
                        jQuery(this).closest(parent).addClass(mClass);
                        if (!window.is_mobile) {
                            wrapper.mCustomScrollbar('update');
                        }
                    }
                );
            } else {
                jQuery(this).closest(parent).find(submenu).stop().fadeOut(function () {
                    400,
                        jQuery(this).closest(parent).removeClass(mClass);
                    if (!window.is_mobile) {
                        wrapper.mCustomScrollbar('update');
                    }
                });
            }
        });
    };

    // open the language box
    window.open_lang_box = window.open_lang_box || function() {
        // vars
        var langBox = $('#languages_menu');
        if (langBox.length == 0) return;
        var link = $('#open_languages');
        var lang_list = $('#custom_lang_list');
        var mClass = ('visible');
        var close = langBox.find('#close_lang');
        // click open
        link.click(function () {
            if (!langBox.hasClass(mClass)) {
                langBox.addClass(mClass);
                setTimeout(function () {
                    valign();
                }, 500);
            }
        });
        // click close
        close.click(function () {
            if (langBox.hasClass(mClass)) {
                langBox.removeClass(mClass);
            }
        });
        // putting margin:
        var lang_list_h = lang_list.outerHeight();
        lang_list.css({
            'margin-top': parseInt((500 - lang_list_h) / 2, 10)
        });
        // click on other parts than menu
        $(document).click(function (event) {
            var closeme = true;
            if ($(event.target).closest(langBox).length > 0) {
                closeme = false;
            }
            if ($(event.target).closest(link).length > 0) {
                closeme = false;
            }
            if (closeme) {
                if (langBox.hasClass(mClass)) {
                    langBox.removeClass(mClass);
                }
            }
        });
    };

    //  openclose content
    window.opencloseviewmore = window.opencloseviewmore || function() {
        var button = $('.view_more_content');
        button.click(function (e) {
            e.stopPropagation();
            // this
            var anchor = $(this);
            var more_text_box = $(this).parent().find('.more_text_box');
            // reset
            var more_text_box_opened = $('.more_text_box.opened');
            if (more_text_box_opened.length > 0) {
                more_text_box_opened.stop().animate({height: 0}, 300, function () {
                    more_text_box_opened.parent().find('.view_more_content').removeClass('open');
                    more_text_box_opened.removeClass('opened');
                });
            }
            if ($(this).hasClass('open')) {
                more_text_box.stop().animate({height: 0}, 300, function () {
                    anchor.removeClass('open');
                    more_text_box.removeClass('opened');
                });
            } else {
                var customHeight = $(this).parent().find('.more_text_box .more_text').outerHeight(true);
                more_text_box.stop().animate({height: customHeight}, 300, function () {
                    anchor.addClass('open');
                    more_text_box.addClass('opened');
                });
            }
        })
    };

    // addthis
    window.addthis_box = function addthis_box() {
        var box = jQuery('.addthis_toolbox');
        var btn = jQuery('.share');
        btn.on('click', function () {
            if (box.is(':visible')) {
                box.fadeOut('slow');
                btn.removeClass('addbox_opened');
            } else {
                box.fadeIn('fast');
                btn.addClass('addbox_opened');
            }
        });

    };

    // WEB SDK OFFERS
    window.webSdkOffers = window.webSdkOffers || function() {
        // START WEB SDK CODE
        $('div[data-websdk]').each(function () {
            // check
            var offers_loading = $(this).hasClass('loading');
            // not going if offers are loaded = no loading class
            if(!offers_loading) return;
            // console.log(offers_loading);
            // not loaded - has class loading and i am in homepage
            if(offers_loading && $('body').hasClass('home')) {
                // position vars
                var offers_pos = $(this).offset().top - $('#header').outerHeight();
                var scrollPosition = window.pageYOffset+window.innerHeight;
                // check if the scroll is less than offer position
                if(scrollPosition <= offers_pos){
                    // no need to load offers
                    return;
                }
            }
            // vars
            var container = $(this);
            var include = container.data('include');
            var model_name = container.data('websdk');
            var id = container.attr('id');
            var custom_template = container.data('websdk-template');
            var template_id;
            var config;
            var model;
            var template;
            var html;
            // setting vars
            template_id = custom_template ? custom_template : '#' + id + '_template';
            template = $(template_id).text();
            if (typeof websdk_config !== 'undefined'
                && typeof websdk_config[id] !== 'undefined'
                && typeof $fbsdk !== 'undefined' ) {
                config = websdk_config[id];
                $fbsdk.baseHost = config.baseHost;
                // OFFERTE
                if (model_name === 'Offers') {
                    model = new $fbsdk[model_name](config.params);
                    model.setAuthToken(config._authCode);
                    model.load(function (error) {
                        var data, i;
                        if (!error) {
                            data = this.getRawData();
                            if(!isEmpty(data.rates)) {

                                // Exclude specific offers based on global FB Options config
                                if (typeof config.excluded_offers !== 'undefined' && config.excluded_offers !== '') {
                                    var temp_rates = [];
                                    for (var i = 0; i < data.rates.length; i++) {
                                        if (typeof data.rates[i] !== 'undefined') {
                                            if ($.inArray(data.rates[i].rate.name, config.excluded_offers) == -1) {
                                                // if is allowed
                                                temp_rates.push(data.rates[i]);
                                            }
                                        }
                                    }
                                    // OVERRRIDE THE OBJ
                                    data.rates = temp_rates;
                                }

                                if (typeof include !== 'undefined' && typeof include.length !== 'undefined' && include.length > 0) {
                                    var temp_rates = [];
                                    for (var i = 0; i < data.rates.length; i++) {
                                        if (typeof data.rates[i] !== 'undefined') {
                                            var rateName = data.rates[i].rate.name;
                                            for (var inc_i = 0; inc_i < include.length; inc_i++) {
                                                var regStr = include[inc_i];
                                                var regExp = new RegExp(regStr);
                                                if (rateName.match(regExp)){
                                                    temp_rates.push(data.rates[i]);
                                                    break;
                                                }
                                            }
                                        }
                                    }
                                    // OVERRRIDE THE OBJ
                                    data.rates = temp_rates;
                                }

                                // limit numbers
                                if (typeof config.offers_number !== 'undefined' && config.offers_number !== '') {
                                    if(data.rates.length > parseInt(config.offers_number, 10)) {
                                        data.rates.length = parseInt(config.offers_number, 10);
                                    }
                                }
                                // debug(data.rates.length);
                                // debug(data.rates);
                                // debug(config);
                                /**
                                 * Esempio di come manipolare i dati prima di buttarli fuori nella pagina (excerpt)
                                 */
                                for (var i = 0; i < data.rates.length; i++) {
                                    if (typeof data.rates[i] !== 'undefined') {
                                        data.rates[i].rate.excerpt = data.rates[i].rate.plain_description.substr(0, 80) + '&hellip;';
                                    }
                                }

                                // VND currency price formatting
                                if (typeof config.params.currency !== 'undefined'
                                    && config.params.currency === 'VND'
                                    && typeof numeral !== 'undefined') {
                                    for (var i = 0; i < data.rates.length; i++) {
                                        if (typeof data.rates[i] !== 'undefined') {
                                            var totalPrice = numeral(data.rates[i].quotation.totalPrice).format('0,0.00');
                                            data.rates[i].quotation.totalPrice = totalPrice;
                                            var pricePerNight = numeral(data.rates[i].quotation.pricePerNight).format('0,0.00');
                                            data.rates[i].quotation.pricePerNight = pricePerNight;
                                        }
                                    }
                                }

                                //Fino a qui possiamo manipolare i dati
                                html = Mustache.render(template, data);
                                container.html(html);
                                if (container.data('cloneto')) {
                                    $(container.data('cloneto')).html(html);
                                }
                                // Finalmente, ho nella mia pagina l'html delle offerte, quindi posso processarlo con jQuery
                                // CALLBACKS
                                container.closest('.special_offers').removeClass('loading');
                                valign();


                                // rooms preview section
                                if (container.closest('#rooms_list').size() > 0) {
                                    container.closest('.preview_content').find('.book').each(function () {
                                        var btn = $(this);
                                        btn.click(function () {
                                            btn.closest('.preview_content').find('a.price_cont').trigger('click');
                                        })
                                    })
                                    container.removeClass('loading');
                                }
                            } else {
                                // NO OFFERS!!!!
                                // CALLBACKS
                                container.closest('.special_offers').removeClass('loading').addClass('no_offers');
                                if(typeof no_offers!=='undefined') {
                                    container.closest('.special_offers').html(no_offers);
                                }
                            }
                        }
                    });
                }

                //ROOM FEATURE
                if (model_name == 'Accommodations') {
                    /**
                     * Buch fixa
                     */
                    $fbsdk.Accommodations.prototype.getURLParams = function () {
                        var toRet = {
                            output: this.getConfig().output,
                            template: this.getConfig().template,
                            locale: this.getConfig().locale,
                            property: this.getConfig().property,
                            offset: this.getConfig().offset,
                            limit: this.getConfig().limit,
                            imagew: this.getConfig().imagew,
                            imageh: this.getConfig().imageh,
                            sortBy: this.getConfig().sortBy,
                            stripTags: this.getConfig().stripTags,
                            onlyBookableRooms: this.getConfig().onlyBookableRooms,
                            orderType: this.getConfig().orderType,
                            _authCode: config._authCode
                        };
                        return toRet;
                    };
                    var curlLoader = new $fbsdk.Loader();
                    curlLoader.add('rooms', new $fbsdk.Accommodations({
                        property: config.params.property,
                        locale: config.params.locale,
                        limit: config.params.limit,
                        template: 'default',
                        output: 'json'
                    }));
                    curlLoader.add('i18n', new $fbsdk.I18n({
                        property: config.params.property,
                        locale: config.params.locale,
                        template: 'default',
                        output: 'json',
                        module: 'accommodations'
                    }));
                    curlLoader.load(function (results) {
                        if (!results.i18n.error && !results.rooms.error) {
                            var rooms = results.rooms.origObject.getRawData();
                            var i18n = results.i18n.origObject.getRawData();
                            var template_data = {rooms: {}};
                            for (var i = 0; i < rooms.rooms.length; i++) {
                                var room = rooms.rooms[i];
                                //console.log(room);
                                var room_name = room.beName;
                                var single_room = {
                                    name: room_name,
                                    occupancy: room.occupancy,
                                    roombathroomfeature_title: i18n["Bathroom features"],
                                    roomequipments_title: i18n["Equipments"],
                                    roomfeature_title: i18n["Room features"],
                                    roombathroomfeature: [],
                                    roomequipments: [],
                                    roomfeature: [],
                                    childlabel: (room.occupancy.maxChildren == 1)
                                };
                                for (var featureType in room.features) {
                                    if (room.features.hasOwnProperty(featureType)) {
                                        single_room['has_' + featureType] = false;
                                        for (var k = 0; k < room.features[featureType].length; k++) {
                                            var string_id = 'accommodation-feature-'  + room.features[featureType][k];
                                            single_room[featureType].push({name: i18n[string_id]});
                                            single_room['has_' + featureType] = true;
                                        }
                                    }
                                }
                                template_data.rooms[room_name] = single_room;

                            }

                            if (typeof config.roomType !== 'undefined') {
                                // adding surface
                                if (typeof config.room_surface !== 'undefined') {
                                    // template_data.rooms[config.roomType][]
                                    // debug(config.roomType);
                                    // debug(template_data.rooms);
                                    // debug(template_data.rooms[config.roomType]);
                                    template_data.rooms[config.roomType]['room_surface'] = config.room_surface
                                }
                                template_data.rooms = [template_data.rooms[config.roomType]];
                            }

                            html = Mustache.render(template, template_data);
                            container.html(html);
                        }
                    });
                }
            }
        });
        // END WEB SDK CODE
    };

    // function for google map
    var is_index = $('html').hasClass('homepage');
    window.google_map = window.google_map || function() {
            if(is_index && !is_mobile){
                var __home_map_loaded = false;
                if( $('#map_canvas').length > 0 ) {
                    var position_map = $('#map_canvas').offset().top - $('#map_canvas').height();
                    $(window).on("scroll", function () {
                        var scrollPosition = window.pageYOffset;
                        if (!__home_map_loaded && scrollPosition >= position_map) {
                            __home_map_loaded = true;
                            if ((jQuery('#map_canvas').length > 0)) {
                                initializeMap('map_canvas', gmap_config);
                                jQuery('#calculate').on('click', function () {

                                    calcRoute();
                                });
                                //this part change the "active" link to the one that is clicked
                                /*jQuery('#itineraryMode a').click(function () {
                                 jQuery('#itineraryMode a').removeClass('active');
                                 jQuery(this).addClass('active');
                                 });*/

                                //this part handle the close_map button
                                jQuery('.close_map').click(function () {
                                    jQuery('#map_directions').fadeOut(function () {
                                        directionsDisplay.setPanel(null);
                                        directionsDisplay.setMap(null);
                                        map.setZoom(gmap_config.map_zoom);
                                        if (gmap_config.set_bounds) {
                                            map.fitBounds(gmap_config.bounds);
                                        } else {
                                            map.setCenter(new google.maps.LatLng(gmap_config.hotel_info.latitude, gmap_config.hotel_info.longitude));
                                        }
                                    });
                                    jQuery('.itineraryPanelWrapper').remove();
                                });
                            }
                        }
                    });
                }

            }  else {
                if ((jQuery('#map_canvas').length > 0)) {
                    initializeMap('map_canvas', gmap_config);
                    jQuery('#calculate').on('click', function () {

                        calcRoute();
                    });
                    //this part change the "active" link to the one that is clicked
                    /*jQuery('#itineraryMode a').click(function () {
                     jQuery('#itineraryMode a').removeClass('active');
                     jQuery(this).addClass('active');
                     });*/

                    //this part handle the close_map button
                    jQuery('.close_map').click(function () {
                        jQuery('#map_directions').fadeOut(function () {
                            directionsDisplay.setPanel(null);
                            directionsDisplay.setMap(null);
                            map.setZoom(gmap_config.map_zoom);
                            if (gmap_config.set_bounds) {
                                map.fitBounds(gmap_config.bounds);
                            } else {
                                map.setCenter(new google.maps.LatLng(gmap_config.hotel_info.latitude, gmap_config.hotel_info.longitude));
                            }
                        });
                        jQuery('.itineraryPanelWrapper').remove();
                    });
                }
            }

        // starting up map template-part

    };

    // mini gallery
    window.mini_gallery = function() {
        var galleries = jQuery('.minigallery');
        var children = galleries.children();
        var start_carousel = false;
        if (galleries.length == 0) return;
        galleries.each(function () {
            var gallery = $(this);
            gallery.imagesLoaded()
                .progress(function (instance, image) {
                })
                .always(function (instance) {
                })
                .done(function (instance) {
                    if(children.length>3 || (is_mobile && children.length>0)){
                        start_carousel = true;
                    } else {
                        start_carousel = false;
                    }
                    if(start_carousel){
                        console.log(start_carousel);
                        console.log(children.length);
                        gallery.on('initialized.owl.carousel', function (event) {
                            gallery.closest('.minigallery_box').removeClass('loading');
                        });
                        gallery.owlCarousel({
                            loop: true,
                            margin: 10,
                            responsive: {
                                0: {
                                    items: 1,
                                    nav: true
                                },
                                768: {
                                    items: 2,
                                    nav: true
                                },
                                992: {
                                    items: 3,
                                    nav: true
                                }
                            }
                        });
                    } else {
                        console.log(start_carousel);
                        console.log(children.length);
                        $('.minigallery_box').removeClass('loading');
                        galleries.addClass('no_carousel');
                    }
                })
                .fail(function () {
                });
        });
    };

    // photogallery
    window.do_gallery = function() {
        var boxContainer = $('#photo_gallery');
        if (boxContainer.length > 0) {

            boxContainer.imagesLoaded()
                .progress(function (instance, image) {
                })
                .always(function (instance) {
                })
                .done(function (instance) {
                    // isotope
                    var $grid = $('.all_filter_gallery').isotope();
                    $('.filter-button-group').on('click', 'a', function () {
                        $('.filter-button-group a').removeClass('active');
                        $(this).addClass('active');
                        var filterValue = $(this).attr('data-filter');
                        $grid.isotope({filter: filterValue});
                    });

                    $grid.on('arrangeComplete', function (event, filteredItems) {

                        if (filteredItems.length <= 10) {
                            $('#viewMorePhotogallery').hide();
                        } else {
                            $('#viewMorePhotogallery').show();
                        }

                    });

                    $('a.fancybox-media').fancybox({
                        padding: 0,
                        openEffect: 'none',
                        closeEffect: 'none',
                        helpers: {
                            media: {}
                        }
                    });

                })
                .fail(function () {
                    if ((typeof (window.console) !== 'undefined') && (typeof (console.log) === 'function')) {
                        console.log('all images loaded, at least one is broken');
                    }
                });
        }
    };

    window.weather = function() {
        // debug(weather_city);
        if ($('#weather').size() == 0 || typeof weather_city == 'undefined') return;

        $.simpleWeather({
            location: weather_city,
            woeid: '',
            unit: 'c',
            success: function (weather) {

                html = '' +
                    '<div class="weather_forecast today">' +
                    '<span class="location"><span class="label">' + str_today + '</span><span class="city">' + weather_city + '</span></span>' +
                    '<span class="weather">' +
                    '<span class="image" style="background-image:url(' + weather.image + ');"></span>' +
                    '</span>' +
                    '<span class="details">' +
                    '<span class="temp">' + weather.temp + '&deg;' + weather.units.temp + '</span>' +
                    '<span class="text"><span class="label">' + str_weather + ':</span> ' + weather.currently + '</span>' +
                    '<span class="wind"><span class="label">' + str_wind + ':</span> ' + weather.wind.direction + ' ' + weather.wind.speed + ' ' + weather.units.speed + '</span>' +
                    '<span class="humidity"><span class="label">' + str_humidity + ':</span> ' + weather.humidity + '%</span>' +
                    '<span class="sunrise"><span class="label">' + str_sunrise + ':</span> ' + weather.sunrise + '</span>' +
                    '<span class="sunset"><span class="label">' + str_sunset + ':</span> ' + weather.sunset + '</span>' +
                    '</span>' +
                    '</div>';

                for (var i = 1; i < weather.forecast.length - 2; i++) {
                    html += '' +
                        '<div class="weather_forecast">' +
                        '<span class="day_of_week">' + weather.forecast[i].day + '</span>' +
                        '<span class="image"><img src="' + weather.forecast[i].image + '"></span>' +
                        '<span class="temp"><span class="temp_high">' + weather.forecast[i].high + '&deg;</span><span class="separator">|</span><span class="temp_low">' + weather.forecast[i].low + '&deg;</span></span>' +
                        '</div>';
                }

                $("#weather").html(html);
            },
            error: function (error) {
                $("#weather").html('<p>' + error + '</p>');
            }
        });
    };

    window.isEmpty = function(obj) {

        // null and undefined are "empty"
        if (obj == null) return true;

        // Assume if it has a length property with a non-zero value
        // that that property is correct.
        if (obj.length > 0)    return false;
        if (obj.length === 0)  return true;

        // If it isn't an object at this point
        // it is empty, but it can't be anything *but* empty
        // Is it empty?  Depends on your application.
        if (typeof obj !== "object") return true;

        // Otherwise, does it have any properties of its own?
        // Note that this doesn't handle
        // toString and valueOf enumeration bugs in IE < 9
        for (var key in obj) {
            if (hasOwnProperty.call(obj, key)) return false;
        }

        return true;
    };

    //
    window.homepage_pop_up = window.homepage_pop_up || function() {
        // elems
        var home_pop_up = jQuery("#home_pop_up");
        if (home_pop_up.length == 0) return false;
        // if (jQuery(window).width()<768) return false;
        var html = home_pop_up.find('.home_pop_up');
        setTimeout(function(){
            $.fancybox({
                content : html
            });
        },500);

    };

    window.handle_social_login = window.handle_social_login || function () {
        jQuery(document).on('click tap','.fake_login', function () {
            if ($('#logout_header').length > 0 && typeof logout_onclick !== 'undefined') {
                logout_onclick();
            } else {
                $('#guestaccount a').trigger('click')
            }
        });
    };

    // lazyload only in homepage
    window.lazyhome = window.lazyhome || function(){
        // LAZYLOAD HOMEPAGE
        if (!jQuery('body').hasClass('home')) return false;
        if (jQuery('.lazy').length===0) return false;
        var myLazyLoad = new LazyLoad({
            elements_selector: ".lazy",
            threshold: 50
        });
    };

    // social pics
    window.social_pics = window.social_pics || function() {
        var pictures = $('.social_carousel');
        var children = pictures.children();
        var start_carousel = false;

        if (pictures.length == 0) return;
        pictures.each(function () {
            var picture = $(this);
            picture.imagesLoaded()
                .progress(function (instance, image) {
                })
                .always(function (instance) {
                })
                .done(function (instance) {
                    if(children.length > 3 || (is_mobile && children.length > 0)){
                        start_carousel = true;
                    } else {
                        start_carousel = false;
                    }
                    if(start_carousel){
                        picture.on('initialized.owl.carousel', function (event) {
                            picture.closest('.social_box').removeClass('loading');
                        });
                        picture.owlCarousel({
                            loop: true,
                            margin: 10,
                            responsive: {
                                0: {
                                    items: 1,
                                    nav: true
                                },
                                768: {
                                    items: 2,
                                    nav: true
                                },
                                992: {
                                    items: 3,
                                    nav: true
                                },
                                1281:{
                                    items: 4,
                                    nav: true
                                }
                            }
                        });
                    } else {
                        // console.log(start_carousel);
                        // console.log(children.length);
                        $('.social_box').removeClass('loading');
                        pictures.addClass('no_carousel');
                    }
                })
        });
    };


    ///////////////////////////////////
    ///////  END FUNCTIONS     /////////
    ///////////////////////////////////


    // WINDOW RESIZE
    jQuery(window).resize(function () {

        // resizing images
        resize_images();

        // detecting screen dimensions
        refresh_size_queries();

        // vertical align
        valign();

        //  slideshow height
        slideshowHeight();

        // languages
        open_lang_box();

    });

    // WINDOW SCROLL
    jQuery(window).scroll(function () {
        // header
        header_scroll();
        // lazy load on homepage
        webSdkOffers();
    });

    /////////////// DOM READY
    $(document).ready(function() {
        //social pics
        social_pics();
        // vars
        window.go_slide = false;
        // loading
        if($('html').hasClass('loading')){
            $('#loading').fadeOut(500,function(){
                $('html').removeClass('loading');
                $(this).css({'z-index':1});
            });
        }
        // resizing images
        resize_images();
        // detecting screen dimensions
        refresh_size_queries();
        // vertical align
        valign();
        //  slideshow height
        slideshowHeight();
        // SLIDESHOW
        doSlideshow('#slideshow .cycle');
        // SEO ?
        $('#seobar').html($('#seobar_wrapper ').html());
        $('#seobar_wrapper').html('');
        // header
        header_scroll();
        // open menu
        menu_open();
        // submenu
        open_submenu();
        // languages
        open_lang_box();
        // open close more
        opencloseviewmore();
        // offers
        webSdkOffers();
        // gmap
        google_map();
        // mini gallery
        mini_gallery();
        // wedding form
        $('a.button.fancy').fancybox({
            padding: 0,
            afterShow: function(){
                var ginput_recaptcha = $('.ginput_recaptcha');
                // console.log(ginput_recaptcha);
                if (typeof renderRecaptcha !== 'undefined') {
                    renderRecaptcha();
                }
            }
        });
        // photogallery
        do_gallery();
        // trust you resize
        if (typeof iFrameResize !== 'undefined') {
            iFrameResize({});
        }
        // addthis box
        addthis_box();
        // general fancybox
        $('.fancy').fancybox({
            padding: 0,
            helpers: {
                title: {
                    type: 'over'
                }
            },
            afterShow: function(){
                var ginput_recaptcha = $('.ginput_recaptcha');
                // console.log(ginput_recaptcha);
                if (typeof renderRecaptcha !== 'undefined') {
                    renderRecaptcha();
                }
            }
        });
        // btn go down on homepage
        go_down();
        // function for weather
        weather();
        // home pop_up
        homepage_pop_up();
        handle_social_login();
        // lazy
        lazyhome();
    });

})(jQuery);




